import numpy as np

def map_screen_to_world(data_screen, date_world):
    # 提取旋转矩阵和平移向量
    Rv2c = data_screen['screen_rotation_matrix']
    Tv2c = data_screen['screen_translation_vector']
    A = date_world['camera_matrix']
    Rw2c = date_world['rotation_matrix']
    Tw2c = date_world['translation_vector']

    # print(Rv2c.shape, Tv2c.shape, A.shape, Rw2c.shape, Tw2c.shape)
    # Rv2c = np.array([[0.965149963314468, -0.0425788059963296, 0.258210366937518],
    #                  [0.0292859832567332, 0.998050610379376, 0.0551117982472064],
    #                  [-0.260053608893949, -0.0456292055736385, 0.964515472193138]])
    
    # Tv2c = np.array([[30.1969654856753], [-49.3107982399140], [507.442359986000]])

    # Rw2c = np.array([[0.963494285110906, 0.0428998912293359, -0.264269487249541],
    #                  [-0.0622337198197605, 0.995928128631295, -0.0652236668576798],
    #                  [0.260395327677015, 0.0792891034977518, 0.962240880128517]])
    
    # Tw2c = np.array([[-15.1799773887131], [-42.2471261981148], [246.921818304047]]) 
     
    # A = np.array([[6944.89018564351,	0,	2709.44699784446],
    #                     [0,	6942.91962497637,	1882.05677580185],
    #                     [0,	0,	1]])
    # print(Rv2c.shape, Tv2c.shape, A.shape, Rw2c.shape, Tw2c.shape)
    # print(np.mean(Rv2c))
    # print(np.mean(Tv2c))
    # print(np.mean(Rw2c))
    # print(np.mean(Tw2c))
    # print(np.mean(A))

    # 计算 nc 和 dw2c
    nc = Rw2c[:, 2]
    nc = nc.reshape(-1, 1)
    if nc[2] < 0:
        nc = -nc
    dw2c = np.abs(nc.T @ Tw2c)

    # 计算 Rs2c 和 Ts2c
    Rs2c = np.linalg.inv(np.eye(3) - 2 * np.outer(nc, nc)) @ Rv2c
    assert Tv2c.shape == nc.shape
    Ts2c = np.linalg.inv(np.eye(3) - 2 * np.outer(nc, nc)) @ (Tv2c - 2 * dw2c * nc)

    # 计算 Rc2w 、Tc2w 、Rs2w 、Ts2w
    Rc2w = np.linalg.inv(Rw2c)
    Tc2w = -Rc2w @ Tw2c

    RTc2w = np.eye(4)
    RTc2w[:3, :3] = Rc2w
    RTc2w[:3, 3] = Tc2w.flatten()

    RTs2c = np.eye(4)
    RTs2c[:3, :3] = Rs2c
    RTs2c[:3, 3] = Ts2c.flatten()
    
    RTs2w = RTc2w @ RTs2c
    Rs2w = RTs2w[:3, :3]
    Ts2w = RTs2w[:3, 3]

    # 定义要保存的数据
    data_to_save = {
        'screen_to_world_rotation': Rs2w,
        'screen_to_world_translation': Ts2w
    }
    return data_to_save