import cv2
import numpy as np
import os

gamma = 2.97
# input_folder = 'imgs/patterns'
input_folder = 'imgs/patterns_2x4/'
output_folder = 'imgs/patterns_2x4_gamma_corrected_'+str(gamma)

os.makedirs(output_folder, exist_ok=True)
n = len(os.listdir(input_folder))
for i in range(n):
    print(os.path.join(input_folder, f'pat{i:02}.bmp'))
    img = cv2.imread(os.path.join(input_folder, f'pat{i:02}.bmp'), cv2.IMREAD_GRAYSCALE)
    img = img / 255.0
    img = img ** (1.0 / gamma)
    img = img * 255.0
    img = img.astype(np.uint8)
    cv2.imwrite(os.path.join(output_folder, f'pat{i:02}.bmp'), img)
